// NoPro - webwork 2007-2013

/*
 * some handy jquery-functions
 */

// 2013-02-05 bugfix: use outerWidth(true) instead of width()


// global vars
CRLF = "\r\n";
JQV = $().jquery;

/* for all jqc-functions jqobjects must have absolute positions */

/* jqo and jq2 have same parentNode or jq2 is $(window) */
function nopro_jqchoff(jqo, jq2) { return ((jq2.offset()) ? jq2.offset().left : 0) + parseInt((jq2.outerWidth(true) - jqo.outerWidth(true)) / 2); }
function nopro_jqcvoff(jqo, jq2) { return ((jq2.offset()) ? jq2.offset().top : 0) + parseInt((jq2.outerHeight(true) - jqo.outerHeight(true)) / 2); }
function nopro_jqch(jqo, jq2) { jqo.css('left', nopro_jqchoff(jqo, jq2) +'px'); }
function nopro_jqcv(jqo, jq2) { jqo.css('top', nopro_jqcvoff(jqo, jq2) +'px'); }

/* center jqo inside parent */
function nopro_jqc2phoff(jqo) { return parseInt((jqo.parent().outerWidth(true) - jqo.outerWidth(true)) / 2); }
function nopro_jqc2pvoff(jqo) { return parseInt((jqo.parent().outerHeight(true) - jqo.outerHeight(true)) / 2); }
function nopro_jqc2ph(jqo) { jqo.css('left', nopro_jqc2phoff(jqo) +'px'); }
function nopro_jqc2pv(jqo) { jqo.css('top', nopro_jqc2pvoff(jqo) +'px'); }

////////////////

function get_urlreq(url) {
    var robj = {};
    var req = url.split('?');
    if(req.length > 1) { $.each(req[1].split('&'), function(k, v) { q=v.split('='); robj[q[0]]=q[1]; }); }
    return robj;
}

function get_cookies(cs) {
    var robj = {};
    $.each(cs.split(';'), function(k, v) { q=v.split('='); robj[q[0].trim()]=q[1]; });
    return robj;
}

function emptybutts() {
    $.each($('input[type="checkbox"]'), function(k,v) {
        if(!v.disabled && !v.checked)  {
	    $(v.form).append('<input type="hidden" name="'+v.name+'" value="off"/>');
	}
    });
    //return false;	// prevent submission
    return true;
}

var jqo_a = null;
function jq_resize(eve, dst) {
    // all vars should be defined in nopro.js
    if(eve == null) { return false; }
    var dot = eve.target;	//  corner of obj to resize
    plane = dot.parentNode;
    jqo_a = dst ? $(dst) : $(plane);

    x0 = eve.clientX;
    y0 = eve.clientY;
    ow1 = $(plane).width();
    oh1 = $(plane).height();
    
    document.onmouseup = usr_done;
    document.onmousemove = jq_resizeit;

    return true;	// continue event-handler-chain
}

function jq_resizeit(eve) {
    if(plane && jqo_a) {
	var dw = eve.clientX - x0;
	var dh = eve.clientY - y0;
	jqo_a.width(ow1 + dw);
	jqo_a.height(oh1 + dh);
    }
    return false;	// end event-handler-chain
}

/* -.-.- */
